package coap_pub;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Random;
import java.util.Scanner;

import org.eclipse.californium.core.CoapClient;
import org.eclipse.californium.core.CoapResponse;
import org.eclipse.californium.core.Utils;
import org.eclipse.californium.core.coap.MediaTypeRegistry;

public class CoAPClientPub {

    public static void main(String[] args) {
    	
    	String topic , adr, msg; 
    	Scanner sc = new Scanner(System.in);
    	URI uri ;
    	
    	if(args.length != 3)
    	{
	    	System.out.print("Enter Broker IP : ");
	    	adr = sc.next();
	    	
	    	System.out.print("Enter topic : ");
	    	topic = sc.next();
	    	
	    	System.out.print("Enter a message : ");
	    	msg = sc.next();
    	}
    	else
    	{
    		adr = args[0];
    		topic = args[1]; 
    		msg = args[2];
    	}

		// input URI from command line arguments
		try {
			uri = new URI("coap://" + adr + ":5683/broker/token1");
		} catch (URISyntaxException e) {
			System.err.println("Invalid URI: " + e.getMessage());
			System.exit(-1);
		}
    	
        CoapClient clients =new CoapClient("coap://" + adr + ":5683/broker/" + topic);
        System.out.println(topic);
        CoapResponse response = clients.put(msg , MediaTypeRegistry.TEXT_PLAIN);
        
        printResponse(response);
        
        System.out.println("CANCELLATION");
    }
    
    public static void randIndex(int[] arr)
    {
    	int[] checker = new int[300];
    	
    	for(int i = 0 ; i < 100 ; i++)
    		checker[i] = 0 ; 
    	
    	Random rand = new Random();
    	
    	int idx ;
    	
    	for(int i = 0 ; i < 300 ; i++)
    	{
	    	for(idx = rand.nextInt(300) ; checker[idx] != 0 ;idx = rand.nextInt(300));
	    	checker[idx] = 1 ;
	    	arr[i] = idx ;
    	}
    		
    	
    }
    public static void printResponse(CoapResponse response) {
		if (response != null) {
			System.out.println(Utils.prettyPrint(response));
		} else {
			System.out.println("No response received.");
		}
	}
}