package coap_server;

import org.eclipse.californium.core.CoapResource;
import org.eclipse.californium.core.coap.CoAP;
import org.eclipse.californium.core.coap.CoAP.Type;
import org.eclipse.californium.core.server.resources.CoapExchange;

public class CoAPMQToken extends CoapResource {

	private String name ; 
	private String contents ; 
	
	public CoAPMQToken(String _name) {
		super(_name);
		name = _name ; 
		setObservable(true);
		setObserveType(Type.CON);
		getAttributes().setObservable();
	}
	
	@Override
	public void handleGET(CoapExchange exchange)
	{
		System.out.println("[Debug - " + name + "] handleGet - " + contents);
		exchange.respond(contents);
	}
	
	@Override
	public void handlePUT(CoapExchange exchange){
		contents = exchange.getRequestText();
		System.out.println("[Debug - " + name + "] handlePUT - " + contents);
		exchange.respond(CoAP.ResponseCode.CHANGED);
		changed();
	}

}