package coap_server;

import java.util.ArrayList;
import java.util.logging.Logger;

import org.eclipse.californium.core.CoapResource;
import org.eclipse.californium.core.CoapServer;
import org.eclipse.californium.core.coap.CoAP;
import org.eclipse.californium.core.coap.CoAP.Type;
import org.eclipse.californium.core.server.resources.CoapExchange;

public class CoAPServer extends CoapResource {

	private Logger log = Logger.getLogger("Broker");
	private static CoapServer server = null; 
	private ArrayList<String> tokens = new ArrayList<String>(); 
	
    public CoAPServer(String name) {
        super(name);
        setObservable(true); // enable observing
        setObserveType(Type.CON); // configure the notification type to CONs
        getAttributes().setObservable(); // mark observable in the Link-Format
    }
    
    @Override
    public void handleGET(CoapExchange exchange) {
        exchange.setMaxAge(1); // the Max-Age value should match the update interval
        System.out.println("Get");
        exchange.respond("hello world");
    }
    
    @Override
    public void handlePOST(CoapExchange exchange)
    {
    	boolean isCurrupted ; 
    	String msg = new String(exchange.getRequestPayload());
		log.info(String.format("Request create token - {tokenid : \"%s\"}" , msg));
		
		isCurrupted = false ; 
		for(String str : tokens)
		{
			if(str.compareTo(msg) == 0)
				isCurrupted = true ;
		}
		
		//ߺ token  ó  !!
		if(!isCurrupted){
			server.add(new CoAPMQToken(msg));
			log.info("Create resource Success");
			this.add(new CoAPMQToken(msg));
			tokens.add(msg);
			exchange.respond(CoAP.ResponseCode.CREATED);
		}else{
			log.info("Create resource Fail");
			exchange.respond(CoAP.ResponseCode.BAD_REQUEST);
		}
    }
    
    @Override
    public void handlePUT(CoapExchange exchange) {
        // ...
        exchange.respond(CoAP.ResponseCode.CHANGED);
        System.out.println("hello world!!");
        changed(); // notify all observers
    }
    
    public static void main(String[] args) {
    	server = new CoapServer();
        server.add(new CoAPServer("broker"));
        server.start();
        
        System.out.println("Start server");
    }

}