package coap_sub;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Scanner;

import org.eclipse.californium.core.CoapClient;
import org.eclipse.californium.core.CoapHandler;
import org.eclipse.californium.core.CoapObserveRelation;
import org.eclipse.californium.core.CoapResponse;
import org.eclipse.californium.core.Utils;
import org.eclipse.californium.core.coap.MediaTypeRegistry;

public class CoAPClientSub {

    public static void main(String[] args) {
    	
    	String adr =null ;
    	String topic = null;; 
    	Scanner sc = new Scanner(System.in);
    	if(args.length != 2)
    	{
	    	System.out.print("Enter Broker IP : ");
	    	sc = new Scanner(System.in);
	    	adr = sc.next();
	    	
	    	System.out.print("Enter topic : ");
	    	sc = new Scanner(System.in);
	    	topic = sc.next();
    	}
    	else
    	{
    		adr = args[0];
    		topic = args[1] ; 
    	}
    	
    	URI uri = null; // URI parameter of the request

		// input URI from command line arguments
		try {
			uri = new URI("coap://" + adr + ":5683/broker/");
		} catch (URISyntaxException e) {
			System.err.println("Invalid URI: " + e.getMessage());
			System.exit(-1);
		}
    	
        CoapClient client = new CoapClient(uri);
     
        CoapResponse response = client.post(topic , MediaTypeRegistry.TEXT_PLAIN);
        printResponse(response);

        client.setURI("coap://" + adr + ":5683/broker/" + topic +"/");
        
        System.out.println("Start Subscription topic - " + topic);
        
        CoapObserveRelation relation = client.observe(
                new CoapHandler() {
                    public void onLoad(CoapResponse response) {
                        String content = response.getResponseText();
                        System.out.println("NOTIFICATION: " + content);
                    }
                    
                    public void onError() {
                        System.err.println("OBSERVING FAILED (press enter to exit)");
                    }
                });
        
        sc.nextLine();
        sc.nextLine();
        
        System.out.println("CANCELLATION");
        relation.proactiveCancel();
    }
    
    public static void printResponse(CoapResponse response) {
		if (response != null) {
			System.out.println(Utils.prettyPrint(response));
		} else {
			System.out.println("No response received.");
		}
	}
}